#pragma once

#include <a8/basehttpsession.h>

#include "framework/cpp/netmsghandler.h"

namespace a8
{
    class MutableXObject;
}

namespace ss
{
    class SS_Ping;
    class SS_GSM_ExecAsyncSql;
}

class HandlerMgr : public a8::Singleton<HandlerMgr>
{

 private:
    HandlerMgr() {};
    friend class a8::Singleton<HandlerMgr>;

 public:
    enum { HID = HID_HandlerMgr };

 public:

    void Init();
    void UnInit();

    f8::NetMsgHandlerObject gsmsghandler;

    void ProcGMMsg(unsigned long saddr, int sockhandle,
                   const std::string& url, const std::string& quyerstr);

    void _SS_Ping(f8::MsgHdr& hdr, const ss::SS_Ping& msg);
    void _SS_GSM_ExecAsyncSql(f8::MsgHdr& hdr, const ss::SS_GSM_ExecAsyncSql& msg);

 private:
    void RegisterNetMsgHandlers();
    void RegisterGMMsgHandler(const std::string& msgname,
                              void (*)(f8::JsonHttpRequest*));

    std::map<std::string, void (*)(f8::JsonHttpRequest*)> gmhandlers_;
};
