#include "precompile.h"

#include "jsondatamgr.h"
#include "app.h"

#include "framework/cpp/utils.h"

void JsonDataMgr::Init()
{
    std::string dbproxyserver_cluster_json_file;
    std::string mysql_cluster_json_file;
    if (!f8::IsOnlineEnv()) {
        dbproxyserver_cluster_json_file = a8::Format("/var/data/conf_test/game%d/dbproxy/game%d.dbproxy.cluster.json",
                                                     {GAME_ID, GAME_ID});
        mysql_cluster_json_file = a8::Format("/var/data/conf_test/game%d/dbproxy/game%d.dbproxy.mysql.cluster.json",
                                             {GAME_ID, GAME_ID});
    } else {
        dbproxyserver_cluster_json_file = a8::Format("../config/game%d.dbproxy.cluster.json", {GAME_ID});
        mysql_cluster_json_file = a8::Format("../config/game%d.dbproxy.mysql.cluster.json", {GAME_ID});
    }
    dbproxyserver_cluster_json_.ReadFromFile(dbproxyserver_cluster_json_file);
    mysql_cluster_json_.ReadFromFile(mysql_cluster_json_file);
}

void JsonDataMgr::UnInit()
{
}

std::shared_ptr<a8::XObject> JsonDataMgr::GetConf()
{
    if (App::Instance()->instance_id < 1 || App::Instance()->instance_id > dbproxyserver_cluster_json_.Size()) {
        abort();
    }
    return dbproxyserver_cluster_json_[App::Instance()->instance_id - 1];
}

std::shared_ptr<a8::XObject> JsonDataMgr::GetMysqlConf()
{
    if (App::Instance()->instance_id < 1 || App::Instance()->instance_id > mysql_cluster_json_.Size()) {
        abort();
    }
    return mysql_cluster_json_[App::Instance()->instance_id - 1];
}
